• E


    点击打开链接


    Mr Wang wants some boys to help him with a project. Because the project is rather complex, the more boys come, the better it will be. Of course there are certain requirements. 

    Mr Wang selected a room big enough to hold the boys. The boy who are not been chosen has to leave the room immediately. There are 10000000 boys in the room numbered from 1 to 10000000 at the very beginning. After Mr Wang's selection any two of them who are still in this room should be friends (direct or indirect), or there is only one boy left. Given all the direct friend-pairs, you should decide the best way. 
    Input
    The first line of the input contains an integer n (0 ≤ n ≤ 100 000) - the number of direct friend-pairs. The following n lines each contains a pair of numbers A and B separated by a single space that suggests A and B are direct friends. (A ≠ B, 1 ≤ A, B ≤ 10000000)
    Output
    The output in one line contains exactly one integer equals to the maximum number of boys Mr Wang may keep. 
    Sample Input
    4
    1 2
    3 4
    5 6
    1 6
    4
    1 2
    3 4
    5 6
    7 8
    Sample Output
    4
    2
    


    暴力枚举,中间有一小部分的优化

    把连在一起的通过join连接在一起然后通过枚举有都少个孩子节点有相同的父亲


    Select Code

    #include<cstdio>
    #include<cstring>
    #include<algorithm>
    using namespace std;
    
    int par[10000005];
    void init(int n)
    {
    	for(int i=1; i<=10000005; i++)
    	par[i]=i;
    }
    
    int find(int x)
    {
    	if(par[x]==x)
    	return x;
    	else
    	return par[x]=find(par[x]);
    }
    
    void join(int x, int y)
    {
    	int fx=find(x),fy=find(y);
    	if(fx!=fy)
    	{
    		par[fx]=fy;
    	}
    }
    int main()
    {
    	int n;
    	while(~scanf("%d",&n))
    	{		
    			if(n==0)			//特判???? 
    			{
    				printf("1
    ");
    				continue;
    			 } 
    			init(n);
    			int maxn=0;
    			for(int i=1; i<=n; i++)
    			{
    				int a,b;
    				scanf("%d%d",&a,&b);
    				join(a,b);
    				if(max(a,b)>maxn)			//优化 
    				{
    					maxn=max(a,b) ;
    				}				
    			}
    			
    			int sum=0,ans=0;			
    			for(int j=1; j<=maxn; j++)
    			{
    				int ans=0;		
    				if(par[j]==j)
    				for(int i=1; i<=maxn; i++)
    				{
    					if(find(i)==j)		//find(i)与par[i]不同?? 
    					ans++;
    				}
    				sum=max(sum,ans);				
    			}
    			printf("%d
    ",sum);		
    	}
    	return 0;
    }



    永远渴望,大智若愚(stay hungry, stay foolish)
  • 相关阅读:
    POJ 1862 Stripies (简单贪心)
    HDU 2181 哈密顿绕行世界问题(DFS)
    POJ 3262 Protecting the Flowers (贪心)
    Aizu 2249 Road Construction (最短路 SPFA)
    POJ 3484 Showstopper(二分)
    HDU 6235 2017-CCPC-哈尔滨站 Permutation(简单模拟)
    IDEA常用插件
    解决IDEA插件加载失败
    解决zsh无法使用maven
    Linux安装Maven
  • 原文地址:https://www.cnblogs.com/h-hkai/p/7406507.html
Copyright © 2020-2023  润新知